Index: GTP/trunk/Lib/Geom/shared/GeoTool/include/GeoMeshViewUI.h
===================================================================
--- GTP/trunk/Lib/Geom/shared/GeoTool/include/GeoMeshViewUI.h	(revision 774)
+++ GTP/trunk/Lib/Geom/shared/GeoTool/include/GeoMeshViewUI.h	(revision 829)
@@ -42,4 +42,5 @@
 #include	"GeoTreeSimpSequence.h"
 #include	"GeoLodStripsConstructor.h"
+#include	"GeoLodTreeLibrary.h"
 
 //	About Dialog.
@@ -58,5 +59,6 @@
 	LODTREES,
 	SELECT_LEAVES,
-	VISUALIZE_LODSTRIPS
+	VISUALIZE_LODSTRIPS,
+	VISUALIZE_LODTREES
 };
 
@@ -96,4 +98,6 @@
 	//	Lod strips object.
 	LodStripsLibrary	*lodStripsLib;
+	//	Lod tree object.
+	LodTreeLibrary	*lodTreeLib;
 	
 	//	Mesh Bounds.
@@ -170,4 +174,6 @@
 	inline void cb_menuLodTreesOpenLeavesSimplification_i(fltk::Item*, void*);
 	static void cb_menuLodTreesOpenLeavesSimplification(fltk::Item*, void*);
+	inline void cb_menuLodTreesVisualize_i(fltk::Item*, void*);
+	static void cb_menuLodTreesVisualize(fltk::Item*, void*);
 	inline void cb_menuHelpAbout_i(fltk::Item*, void*);
 	static void cb_menuHelpAbout(fltk::Item*, void*);
@@ -206,5 +212,5 @@
 	
 	//	Show the LodStrips visulization panel.
-	void	showVisualizeLodStrips();
+	void	showSlider();
 
 	void	hideStripify();
@@ -218,5 +224,5 @@
 
 	//	Hide the LodStrips visualization panel.
-	void	hideVisualizeLodStrips();
+	void	hideSlider();
 	
 	//	Get the number of vertices.
@@ -292,4 +298,5 @@
 	fltk::Item					*menuLodStripsVisualize;
 	fltk::ItemGroup			*menuLodTrees;
+	fltk::Item					*menuLodTreesVisualize;
 
 	fltk::Item					*menuSelectLeaves;
@@ -333,4 +340,6 @@
 	//	Initialize the lodstripslibrary for visualization.
 	void	setLodStripsLibrary(std::string lodfile, Mesh	*geomesh);
+	//	Initialize the lodtreelibrary for visualization.
+	void	setLodTreesLibrary(std::string lodfile, Mesh	*geomesh);
 
 	// 26-12-2005
Index: GTP/trunk/Lib/Geom/shared/GeoTool/include/GeoMeshView.h
===================================================================
--- GTP/trunk/Lib/Geom/shared/GeoTool/include/GeoMeshView.h	(revision 826)
+++ GTP/trunk/Lib/Geom/shared/GeoTool/include/GeoMeshView.h	(revision 829)
@@ -14,6 +14,7 @@
 #include	<GeoMeshSaver.h>
 #include	<GeoMeshViewUI.h>
-//#include	<GeoLodStripsLibrary.h>
+
 //#endif
+namespace Geometry{ class LodTreeLibrary; }
 
 class GeoMeshView : public fltk::GlWindow
@@ -33,4 +34,5 @@
 	bool		mRotate;
 	bool		mLodStrip;
+	bool		mLodTree;
 
 	GeoMeshView(int 					x,
@@ -94,18 +96,23 @@
 
 	//	Counter Clockwise mode.
-	void	activeCCW(){mCCW	=	true;};
-	void	deactiveCCW(){mCCW	=	false;};
+	void	activeCCW(){mCCW	=	true;}
+	void	deactiveCCW(){mCCW	=	false;}
 
 	//	Pan mode.
-	void	activePan(){mPan	=	true;};
-	void	deactivePan(){mPan	=	false;};
+	void	activePan(){mPan	=	true;}
+	void	deactivePan(){mPan	=	false;}
 
 	//	Rotate mode.
-	void	activeRotate(){mRotate	=	true;};
-	void	deactiveRotate(){mRotate	=	false;};
+	void	activeRotate(){mRotate	=	true;}
+	void	deactiveRotate(){mRotate	=	false;}
 
 	//	LodStrip mode.
-	void	activeLodStrip(){mLodStrip	=	true;};
-	void	deactiveLodStrip(){mLodStrip	=	false;};
+	void	activeLodStrip(){mLodStrip	=	true;}
+	void	deactiveLodStrip(){mLodStrip	=	false;}
+
+	//	LodTree mode.
+	void	activeLodTree(){mLodTree	=	true;}
+	void	deactiveLodTree(){mLodTree	=	false;}
+
 
 	//	Ilumination modes.
@@ -158,4 +165,6 @@
 	//	Sets the lodstripslibrary object.
 	void	setLodStripsLibrary(Geometry::LodStripsLibrary *lodstrips);
+	//	Sets the lodtreeslibrary object.
+	void	setLodTreesLibrary(Geometry::LodTreeLibrary *lodtrees);
 
 	//	Change de Level of detail of the object.
@@ -174,4 +183,6 @@
 	//	LodStrips library object.
 	Geometry::LodStripsLibrary	*lodStripsLib;
+	//	LodTree library object.
+	Geometry::LodTreeLibrary	*lodTreeLib;
 	
 	//	Flag tha activate / deactivate the color strips.
@@ -206,4 +217,5 @@
 	void	drawTriangleStrip(int submesh);
 	void	drawLodStrip();
+	void	drawLodTree();
 	void	enableColorStrips();
 	void	disableColorStrips();